require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_CPUFUNC_H_)) {
    eval 'sub _MACHINE_CPUFUNC_H_ () {1;}' unless defined(&_MACHINE_CPUFUNC_H_);
    require 'machine/psl.ph';
    require 'machine/pte.ph';
    eval 'sub tlbbtop {
        my($b) = @_;
	    eval q((($b) >> ( &PGSHIFT - 5)));
    }' unless defined(&tlbbtop);
    eval 'sub tlbptob {
        my($p) = @_;
	    eval q((($p) << ( &PGSHIFT - 5)));
    }' unless defined(&tlbptob);
    eval 'sub hptbtop {
        my($b) = @_;
	    eval q((($b) >> 17));
    }' unless defined(&hptbtop);
    eval 'sub mtctl {
        my($v,$r) = @_;
	    eval q( &__asm  &__volatile(\\"mtctl %0,%1\\":: \\"r\\" ($v), \\"i\\" ($r)));
    }' unless defined(&mtctl);
    eval 'sub mfctl {
        my($r,$v) = @_;
	    eval q( &__asm  &__volatile(\\"mfctl %1,%0\\": \\"=r\\" ($v): \\"i\\" ($r)));
    }' unless defined(&mfctl);
    eval 'sub mfcpu {
        my($r,$v) = @_;
	    eval q( &__asm  &__volatile(\\".word	%1\\\\n\\\\t\\" \\"copy	%%r22, %0\\" : \\"=r\\" ($v) : \\"i\\" ((0x14001400 | (($r) << 21) | (22))) : \\"r22\\"));
    }' unless defined(&mfcpu);
    eval 'sub mtsp {
        my($v,$r) = @_;
	    eval q( &__asm  &__volatile(\\"mtsp %0,%1\\":: \\"r\\" ($v), \\"i\\" ($r)));
    }' unless defined(&mtsp);
    eval 'sub mfsp {
        my($r,$v) = @_;
	    eval q( &__asm  &__volatile(\\"mfsp %1,%0\\": \\"=r\\" ($v): \\"i\\" ($r)));
    }' unless defined(&mfsp);
    eval 'sub ssm {
        my($v,$r) = @_;
	    eval q( &__asm  &__volatile(\\"ssm %1,%0\\": \\"=r\\" ($r): \\"i\\" ($v)));
    }' unless defined(&ssm);
    eval 'sub rsm {
        my($v,$r) = @_;
	    eval q( &__asm  &__volatile(\\"rsm %1,%0\\": \\"=r\\" ($r): \\"i\\" ($v)));
    }' unless defined(&rsm);
    eval 'sub fdce {
        my($sp,$off) = @_;
	    eval q( &__asm  &__volatile(\\"fdce 0(%0,%1)\\":: \\"i\\" ($sp), \\"r\\" ($off)));
    }' unless defined(&fdce);
    eval 'sub fice {
        my($sp,$off) = @_;
	    eval q( &__asm  &__volatile(\\"fice 0(%0,%1)\\":: \\"i\\" ($sp), \\"r\\" ($off)));
    }' unless defined(&fice);
    eval 'sub sync_caches () {
        eval q( &__asm  &__volatile( \\"sync\\\\n\\\\tnop\\\\n\\\\tnop\\\\n\\\\tnop\\\\n\\\\tnop\\\\n\\\\tnop\\\\n\\\\tnop\\\\n\\\\tnop\\":::\\"memory\\"));
    }' unless defined(&sync_caches);
    eval 'sub iitlba {
        my($pg,$sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"iitlba %0,(%%sr1, %1)\\":: \\"r\\" ($pg), \\"r\\" ($va)); });
    }' unless defined(&iitlba);
    eval 'sub idtlba {
        my($pg,$sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"idtlba %0,(%%sr1, %1)\\":: \\"r\\" ($pg), \\"r\\" ($va)); });
    }' unless defined(&idtlba);
    eval 'sub iitlbp {
        my($prot,$sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"iitlbp %0,(%%sr1, %1)\\":: \\"r\\" ($prot), \\"r\\" ($va)); });
    }' unless defined(&iitlbp);
    eval 'sub idtlbp {
        my($prot,$sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"idtlbp %0,(%%sr1, %1)\\":: \\"r\\" ($prot), \\"r\\" ($va)); });
    }' unless defined(&idtlbp);
    eval 'sub pitlb {
        my($sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"pitlb %%r0(%%sr1, %0)\\":: \\"r\\" ($va)); });
    }' unless defined(&pitlb);
    eval 'sub pdtlb {
        my($sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"pdtlb %%r0(%%sr1, %0)\\":: \\"r\\" ($va)); });
    }' unless defined(&pdtlb);
    eval 'sub pitlbe {
        my($sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"pitlbe %%r0(%%sr1, %0)\\":: \\"r\\" ($va)); });
    }' unless defined(&pitlbe);
    eval 'sub pdtlbe {
        my($sp,$va) = @_;
	    eval q({  &mtsp($sp, 1);  &__asm  &volatile(\\"pdtlbe %%r0(%%sr1, %0)\\":: \\"r\\" ($va)); });
    }' unless defined(&pdtlbe);
    if(defined(&USELEDS)) {
	eval 'sub PALED_NETSND () {0x1;}' unless defined(&PALED_NETSND);
	eval 'sub PALED_NETRCV () {0x2;}' unless defined(&PALED_NETRCV);
	eval 'sub PALED_DISK () {0x4;}' unless defined(&PALED_DISK);
	eval 'sub PALED_HEARTBEAT () {0x8;}' unless defined(&PALED_HEARTBEAT);
	eval 'sub PALED_LOADMASK () {0xf0;}' unless defined(&PALED_LOADMASK);
	eval 'sub PALED_DATA () {0x1;}' unless defined(&PALED_DATA);
	eval 'sub PALED_STROBE () {0x2;}' unless defined(&PALED_STROBE);
	eval 'sub ledctl {
	    my($on,$off,$toggle) = @_;
    	    eval q({  &if ( &machine_ledaddr) { \'int\'  &r;  &if ($on)  &machine_leds |= $on;  &if ($off)  &machine_leds &= ~$off;  &if ($toggle)  &machine_leds ^= $toggle;  &r = ~ &machine_leds;  &if ( &machine_ledword) * &machine_ledaddr =  &r;  &else {  &register \'int\'  &b;  &for ( &b = 0x80;  &b;  &b >>= 1) { * &machine_ledaddr = ( &r &  &b)?  &PALED_DATA : 0;  &DELAY(1); * &machine_ledaddr = (( &r &  &b)?  &PALED_DATA : 0) |  &PALED_STROBE; } } } });
	}' unless defined(&ledctl);
    }
    if(defined(&_KERNEL)) {
    }
}
1;
